"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) {
  function isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  return function () {
    var Super = _getPrototypeOf(Derived),
        result;

    if (isNativeReflectConstruct()) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var clamp = function clamp(value, left, right) {
  return Math.min(Math.max(value, left), right);
};

var TipContainer =
/*#__PURE__*/
function (_Component) {
  _inherits(TipContainer, _Component);

  var _super = _createSuper(TipContainer);

  function TipContainer() {
    var _this;

    _classCallCheck(this, TipContainer);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      height: 0,
      width: 0
    });

    _defineProperty(_assertThisInitialized(_this), "updatePosition", function () {
      var container = _this.refs.container;
      var offsetHeight = container.offsetHeight,
          offsetWidth = container.offsetWidth;

      _this.setState({
        height: offsetHeight,
        width: offsetWidth
      });
    });

    return _this;
  }

  _createClass(TipContainer, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(nextProps) {
      if (this.props.children !== nextProps.children) {
        this.updatePosition();
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      setTimeout(this.updatePosition, 0);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          children = _this$props.children,
          style = _this$props.style,
          scrollTop = _this$props.scrollTop,
          pageBoundingRect = _this$props.pageBoundingRect;
      var _this$state = this.state,
          height = _this$state.height,
          width = _this$state.width;
      var isStyleCalculationInProgress = width === 0 && height === 0;
      var shouldMove = style.top - height - 5 < scrollTop;
      var top = shouldMove ? style.bottom + 5 : style.top - height - 5;
      var left = clamp(style.left - width / 2, 0, pageBoundingRect.width - width);

      var childrenWithProps = _react["default"].Children.map(children, function (child) {
        return _react["default"].cloneElement(child, {
          onUpdate: function onUpdate() {
            _this2.setState({
              width: 0,
              height: 0
            }, function () {
              setTimeout(_this2.updatePosition, 0);
            });
          },
          popup: {
            position: shouldMove ? "below" : "above"
          }
        });
      });

      return _react["default"].createElement("div", {
        className: "PdfHighlighter__tip-container",
        style: {
          visibility: isStyleCalculationInProgress ? "hidden" : "visible",
          top: top,
          left: left
        },
        ref: "container"
      }, childrenWithProps);
    }
  }]);

  return TipContainer;
}(_react.Component);

var _default = TipContainer;
exports["default"] = _default;